class Ports {
  // Use the ports to create the hose lines
  
 Hoses[] hoseImage = new Hoses[500];
  
  int x;                                        // what position of port
  int y;        
  int compType;                                 // what component is it on 
  PImage portImg;                               // Port graphic
  int numHose;                                  // What hose number is port connected to
  int portNum;                                  // Port number of total ?? same as index of port?
  int[] portFunc = new int[4]; // 1 = input 1, -1 = output 1, -2 = input 2, -2 = output 2, etc.
  
  // controls whether we are dragging (holding the mouse)
  boolean hold; 
 
  // constructor
  Ports(int posx, int posy, int pNum, 
    String imageNameAsString) { 
    x=posx;
    y=posy;   
    portNum = pNum;
    portImg = loadImage(imageNameAsString);
    portImg.resize(13,0); // optional

    for(int z=0;z<260;z++)                          // Create 260 hose line objects
      hoseImage[z]=new Hoses();
    
  }// constructor
 
  void display(int redValue) {
   //    pushMatrix();   // played with rotation
   //   translate(imgX+portImg.width/2,imgY+portImg.height/2); //x + compImg.width, y+ compImg.height);
   //    rotate(radians(angle));
   
   if ((numHose == -1) && (compType != 0))
       tint (redValue,255-redValue,0); //(247,88,63);
   else 
       tint (255,255,0); 
   image(portImg,x, y);
   noTint();
   //   popMatrix();
   // port[4*compNum+0].setPos(x+(compImg.width / 2)-20,y + compImg.height+2);
  }
  
  boolean getHold(){
    return hold;
  }
  
  void setPos(int xPos, int yPos) {             // set the position of the port object
    x = xPos;
    y = yPos;
  }
  
  void setComp(int type){                       // set what component it's on
    compType = type;
  }
  
  int getComp(){
    return compType;
  }
  
  int getX(){
    return x;}
  
  int getY(){
    return y;}
  
  void setHoseNum(int iHose){                  // Set/get what hose is connected to this port
    numHose = iHose;    
  }
  
  int getHoseNum(){
    return numHose;    
  }

     boolean mouseOver(){
    if (mouseX>x&&
      mouseY>y&&
      mouseX<x+portImg.width && 
      mouseY<y+portImg.height) 
        return true;
      else
        return false;
 }
 
  int connMousePressed() {                    // mouse click
    if (mouseX>x&&                            // a connector is clicked?
      mouseY>y&&
      mouseX<x+portImg.width && 
      mouseY<y+portImg.height)  
         return portNum; else return -1;      // if yes, return the portNum that is clicked
  }
 
  void setPortFunc(int num, int func){        // set-get the function of the port (see top).
    portFunc[num] = func;
  }
  
  int getPortFunc(int num){
    return portFunc[num];
  }
  
  void removePort(int cNum){
    if (int(portNum / 4) == cNum)
      x = y = -100;
        
  }
    
}
